﻿version
6.50
-1
4
o:Object
eventMouseDown:Event
Door:Object
obj:Object
Sub designer
end sub
@EndOfDesignText@
'Version 1.10
Sub Globals
	Dim currentTable
	Dim tableName
	MAX_TABLES = 10
	Dim Type(tableName, color, validator, setCombo) tables(MAX_TABLES)
	Dim Type(col,row,rowHeight,rowStart,x,y, margin) editTable
	count = 0
End Sub

Public Sub SetEdit (table, validator, setCombo)
	If count = MAX_TABLES Then
		Msgbox("Cannot add any more tables." & CRLF & "Please increase MAX_TABLES value.")
		Return
	End If
	If count = 0 Then
		AddTimer("Timer1")
		AddPanel("Main.Form1","pnlEdit",20,20,110,26)
		AddTextBox("pnlEdit","txtEdit",2,2,22,22,"")
		AddImageButton("pnlEdit","btnAccept",2,2,25,20,"")
		AddComboBox("pnlEdit","cmbEdit",2,2,22,22)
		btnAccept.Mode = cCenterImage
		btnAccept.Transparent = False
		cmbEdit.Visible = False
		pnlEdit.BringToFront
		pnlEdit.visible = False
		btnAccept.Image = "x.jpg"
		timer1.Interval = 10
	End If
	obj.New1(True) 
	o.New1(False) 
	'Add the MouseDown event
	obj.FromControl(table)
	AddObject("eventMouseDown" & count,"Event")
	Control("eventMouseDown"&count,Event).New1(obj.Value,"MouseDown") 'add the MouseDown event
	AddEvent("eventMouseDown" & count,NewEvent,"eventMouseDown_NewEvent")
	If cPPC Then editTable.margin = 5 Else editTable.margin = 1
	tables(count).color = Control(table,Table).Color
	tables(count).tableName = table
	tables(count).setCombo = setCombo
	tables(count).validator = validator
	AddObject("eventScrollH" & count,"Event")
	AddObject("eventScrollV" & count,"Event")
	o.Value = obj.GetProperty("Controls")
	Control("eventScrollH" & count, Event).New1(o.GetProperty2("Item",0),"ValueChanged")
	Control("eventScrollV" & count, Event).New1(o.GetProperty2("Item",1),"ValueChanged")
	AddEvent("eventScrollV" & count, NewEvent,"eventScroll_NewEvent")
	AddEvent("eventScrollH" & count, NewEvent,"eventScroll_NewEvent")
	count = count + 1
End Sub
Sub eventScroll_NewEvent
	pnlEdit.Visible = False
End Sub

Sub eventMouseDown_NewEvent
	If Timer1.Enabled = True Then Return
	currentTable = SubString(Sender,StrLength("eventMouseDown"),2)
	TableName = tables(currentTable).tableName
	pnlEdit.Color = tables(currentTable).color
	txtEdit.Color = tables(currentTable).color 
	cmbEdit.Color = tables(currentTable).color 
	btnAccept.Color = tables(currentTable).color 
	o.Value = Control(Sender,Event).Data
	editTable.x = o.GetProperty("X") 'Find the mouse position
	editTable.y = o.GetProperty("Y")
	obj.FromControl(TableName)
	o.Value = obj.RunMethod3("HitTest",editTable.x,"System.Int32",editTable.y,"System.Int32")
	If o.GetProperty("Type") <> "Cell" Then Return 'Make sure that the user has selected a cell.
	editTable.col = Control(TableName,Table).ColName(o.GetProperty("Column"))
	editTable.row = o.GetProperty("Row")
	Timer1.Enabled = True 'Let the table control rearrange itself if required (hidden columns / rows).
End Sub

Sub Timer1_Tick
	Timer1.Enabled = False
	If editTable.rowHeight = 0 Then CalcRowSize 'Find the rows layout on the first press.
	pnlEdit.Left = CalcColumnPosition(Control(TableName,Table).ColNumber(editTable.col)) 'Calculate the column beginning.
	fix = (editTable.y - editTable.rowStart) Mod editTable.rowHeight
	If fix < editTable.margin Then 'Too close to the lower border of the cell
		editTable.y = editTable.y - editTable.rowHeight
	End If
	pnlEdit.Top =editTable.y + Control(TableName,Table).Top - fix
	pnlEdit.Width = Control(TableName,Table).ColWidth(editTable.col) + 20
	txtEdit.Width = pnlEdit.Width - 27
	btnAccept.Left = pnlEdit.Width - 25
	pnlEdit.Visible = True 'Show the panel
	value = Control(TableName,Table).Cell(editTable.col,editTable.row)
	If tables(currentTable).setCombo <> "" AND _ 
		CallSub(tables(currentTable).setCombo,editTable.col,"EditableTable.cmbEdit", value) Then
			cmbEdit.Visible = True
			cmbEdit.Width = txtEdit.Width
			cmbEdit.BringToFront
			txtEdit.Visible = False
			cmbEdit.Focus
	Else
		cmbEdit.Visible = False
		txtEdit.Visible = True
		txtEdit.Text = value
		txtEdit.SelectionLength = StrLength(txtEdit.Text)
		txtEdit.Focus
	End If
End Sub
Sub CalcColumnPosition (colNumber)
	x = editTable.x
	o.Value = obj.RunMethod3("HitTest",x,"System.Int32",editTable.y,"System.Int32")
	'This condition happens when the last row is partially hidden.
	If o.GetProperty("Type") = "None" Then editTable.y = editTable.y - editTable.rowHeight
	Do While x > 1 'Find the left border
		o.Value = obj.RunMethod3("HitTest",x,"System.Int32",editTable.y,"System.Int32")
		If o.GetProperty("Column") < colNumber Then Exit
		x = x - 20
	Loop
	x = x + 2
	Do While x < editTable.x 'Refine its position.
		o.Value = obj.RunMethod3("HitTest",x,"System.Int32",editTable.y,"System.Int32")
		If o.GetProperty("Column") >= colNumber Then Exit
		x = x + 2
	Loop
	'If selected row is the last visible row.
	If o.GetProperty("Row") > editTable.row Then editTable.y = editTable.y - editTable.rowHeight
	If cPPC Then x = x - 3
	Return x + Control(TableName,Table).Left
End Sub
Sub CalcRowSize 
	y = 1
	shouldRemoveLastRow = False
	If Control(TableName,Table).RowCount = 1 Then
		shouldRemoveLastRow = True
		Control(TableName,Table).AddRow()
	End If
	obj.FromControl(TableName)
	Do While y < 50
		o.Value = obj.RunMethod3("HitTest",5,"System.Int32",y,"System.Int32")
		If o.GetProperty("Type") = "Cell" Then Exit
		y = y + 1
	Loop
	editTable.rowStart = y-1
	firstRow = o.GetProperty("Row")
	row = firstRow
	Do While y < 100
		o.Value = obj.RunMethod3("HitTest",5,"System.Int32",y,"System.Int32")
		If row = firstRow AND o.GetProperty("Row") = firstRow + 1 Then
			row = firstRow + 1
			y2 = y
		End If
		If row = firstRow + 1 AND _ 
			(o.GetProperty("Type") = "None" OR o.GetProperty("Row") = firstRow + 2) Then Exit
		y = y + 1
	Loop
	If shouldRemoveLastRow Then Control(TableName,Table).RemoveRow(1)
	editTable.rowHeight = y - y2 
End Sub
Sub btnAccept_Click
	If cmbEdit.Visible = True Then
		value = cmbEdit.Item(CmbEdit.SelectedIndex)
	Else
		value = txtEdit.Text
	End If
	pnlEdit.Visible = False
	If tables(currentTable).validator <> "" AND _ 
		CallSub(tables(currentTable).validator,Control(TableName,Table).SelectedCol,value) = False Then
			Return
	End If
	Control(TableName,Table).Cell(Control(TableName,Table).SelectedCol, _ 
		Control(TableName,Table).SelectedRow) =value
End Sub